#ifndef PLEX_H
#define PLEX_H

typedef struct {
  int i;
  int j;
  int end;
  char *structure;
  double energy;
  double energy_backtrack;
  double opening_backtrack_x;
  double opening_backtrack_y;
  int offset;
  double dG1;
  double dG2;
  double ddG;
  int tb;
  int te;
  int qb;
  int qe;
} duplexT;

extern int subopt_sorted;


extern duplexT** Lduplexfold(const char *s1, const char *s2, const int threshold, const int extension_cost, const int alignment_length, const int delta, const int fast,const int il_a, const int il_b, const int b_a, const int b_b);
extern duplexT** Lduplexfold_XS(const char*s1, const char* s2, const int **access_s1, const int **access_s2, const int threshold,  const int delta, const int alignment_length, const int fast,const int il_a, const int il_b, const int b_a, const int b_b);//, const int target_dead, const int query_dead);
extern duplexT** FLduplexfold_XS(const char*s1, const char* s2, const int **access_s1, const int **access_s2, const int threshold,  const int delta, const int alignment_length, const int fast,const int il_a, const int il_b, const int b_a, const int b_b);//, const int target_dead, const int query_dead);
extern duplexT** Lduplexfold_C(const char *s1, const char *s2, const int threshold, const int extension_cost, const int alignment_length, const int delta, const int fast, const char* structure,const int il_a, const int il_b, const int b_a, const int b_b);
extern duplexT** Lduplexfold_CXS(const char*s1, const char* s2, const int **access_s1, const int **access_s2, const int threshold,  const int delta, const int alignment_length, const int fast,const char* structure,const int il_a, const int il_b, const int b_a, const int b_b);//, const int target_dead, const int query_dead);




/* extern duplexT duplexfold_XS(const char *s1, const char *s2,const int **access_s1, const int **access_s2, const int i_pos, const int j_pos, const int align_i, const int align_j, const int threshold); */



extern int      arraySize(duplexT** array);
extern void     freeDuplexT(duplexT** array);

#endif
